
#ifndef TIMEVIEW_H
#define TIMEVIEW_H

#include <StringView.h>
#include <View.h>

class TimeView : public BView
{
public:
    TimeView( BRect const& frame, int32 const& replyCode = 0,
                BLooper* replyLooper = NULL, BHandler* replyHandler = NULL );
    
    virtual void Pulse( void );
    
    void Init( void );
    void Start( void );
    void Stop( void );
    void Switch( void );

    void SetTimeWhite( int const& time );
    void SetTimeBlack( int const& time );
    void SetTime( int const& time );

    int const& GetTimeWhite( void ){ return( fTimeWhite ); }
    int const& GetTimeBlack( void ){ return( fTimeBlack ); }

    virtual	void SetViewColor(rgb_color c)
    {
        BView::SetViewColor( 0,0,0 );
    }
    
    void				SetViewColor(uchar r, uchar g, uchar b,
									uchar a = 255)
    {
            BView::SetViewColor( 0,0,0 );
    }

private:
    
    void _DisplayTimeWhite( void );
    void _DisplayTimeBlack( void );

    void _NotifyTime( void );
    
    BString _TimeToString( int time );

    BStringView*		fWhiteClock;
    BStringView*		fBlackClock;	
    
    bool    fIsRunning;
    bool    fIsTurnWhite;

    int     fTimeWhite;
    int     fTimeBlack;
    
	int     fPulseRate;
    int     fPulses;

    int32   fReplyCode;
    
    BLooper*    fReplyLooper;
    BHandler*   fReplyHandler;
};

#endif
