
#include "mainwindow.h"

#include <Button.h>
#include <GroupLayout.h>
#include <GroupLayoutBuilder.h>
#include <SpaceLayoutItem.h>
#include <SplitLayoutBuilder.h>
#include <StringView.h>
#include <GLView.h>
#include <ListView.h>

#include <TextControl.h>

#include <iostream>

using namespace std;

MainWindow :: MainWindow( BRect const& frame ) 
	: BWindow( frame, "Press Start and  resize the SplitLayout. Bug?",
		B_TITLED_WINDOW, 
		B_ASYNCHRONOUS_CONTROLS | B_QUIT_ON_WINDOW_CLOSE
			/*| B_WILL_ACCEPT_FIRST_CLICK*/ 
			/*| B_AUTO_UPDATE_SIZE_LIMITS*/ | B_OUTLINE_RESIZE )
{
	
	fTimeView = new TimeView( BRect(), 45, this, this );
	

	BButton* fTest = new BButton( "Start", new BMessage( 100)  );
	
	
	fTest->SetFontSize( 20 );
    
    
	SetLayout( new BGroupLayout( B_HORIZONTAL ) );
	
	AddChild
	(
		BSplitLayoutBuilder( B_HORIZONTAL , 10 )
			.Add
			(	
				BGroupLayoutBuilder( B_HORIZONTAL, 10 )
				//.AddGlue()
				.AddGroup( B_VERTICAL, 5 ).GetTopView( &fLeftColumn )
					.Add( BSpaceLayoutItem::CreateVerticalStrut( 0 ) )
					.AddGroup( B_VERTICAL, 0 )
						.AddGlue()
						.Add( fTest )
						.AddGlue()
					.End()
					.Add( BSpaceLayoutItem::CreateVerticalStrut( 0 ) )
					//.AddGlue()
				.End()
				
				.AddGroup( B_VERTICAL, 5 ).GetTopView( &fMiddleColumn )
					.AddGroup( B_HORIZONTAL, 0 )
						.AddGlue()
						.Add( fTimeView )
						.AddGlue()
					.End()
					.Add( new BGLView( BRect(), "GLView",
							B_FOLLOW_ALL_SIDES, B_WILL_DRAW | B_NAVIGABLE, 
							BGL_RGB | BGL_DOUBLE | BGL_DEPTH | BGL_ALPHA  ) )
				.End(), 8 
			)
			.Add
			( 
				BGroupLayoutBuilder( B_HORIZONTAL, 10 )
				//.AddGlue()
				.AddGroup( B_VERTICAL, 5 ).GetTopView( &fRightColumn )
					.AddGlue()
					.Add( new BListView( Bounds(), "moves_list",
							B_SINGLE_SELECTION_LIST, B_FOLLOW_ALL) )
					.AddGlue()
				.End(), 2
			)

	);
	
	BGroupLayout* leftLayout 	= static_cast< BGroupLayout* >( fLeftColumn->GetLayout() );
	BGroupLayout* middleLayout 	= static_cast< BGroupLayout* >( fMiddleColumn->GetLayout() );
	BGroupLayout* rightLayout	= static_cast< BGroupLayout* >( fRightColumn->GetLayout()  );
	
	leftLayout->AlignLayoutWith( middleLayout, B_VERTICAL );
	rightLayout->AlignLayoutWith( middleLayout, B_VERTICAL ); 
	
	//fTest->SetHighColor( 100, 0, 100 );
	fTest->SetLowColor( 100, 0, 0 );
		
	
    fTimeView->Init();
    fTimeView->SetTime( 300 );
}


MainWindow :: ~MainWindow( )
{
	
}


void MainWindow :: MessageReceived( BMessage* message )
{
	switch( message->what )
	{
		
		case 100:
			fTimeView->Start();
			break;
			
		case 90:
			fTimeView->Stop();
			break;
		
		
		default:
			BWindow :: MessageReceived( message );
			break;
	}	
}
